import controlP5.*;

ControlP5 ui;

float[] A = { 0, 0, 0, 0 };
float[] f = { 0, 0, 0, 0 };
float[] d = { 0, 0, 0, 0 };
float[] p = { 0, 0, 0, 0 };

float eval( float t, float A, float f, float p, float d )
{
  return A * sin( t * f + p ) * exp( -d * t );
}

float evalX( float t )
{
  return eval( t, A[0], f[0], p[0], d[0] ) +
    eval( t, A[1], f[1], p[1], d[1] );
}

float evalY( float t )
{
  return eval( t, A[2], f[2], p[2], d[2] ) +
    eval( t, A[3], f[3], p[3], d[3] );
}

void setup()
{
  size( 800, 600 );
  ui = new ControlP5( this );

  background( 50 );
  noFill();
  stroke( 255 );

  for ( int idx = 0; idx < 4; ++idx ) {
    ui.addSlider( "A" + (idx+1) )
      .setPosition( 10 + 175 * idx, 5 )
      .setRange( 0, 300 )
      .setSize( 150, 20 );
    ui.addSlider( "f" + (idx+1) )
      .setPosition( 10 + 175 * idx, 30 )
      .setRange( 0, 20 )
      .setSize( 150, 20 );
    ui.addSlider( "p" + (idx+1) )
      .setPosition( 10 + 175 * idx, 55 )
      .setRange( 0, TWO_PI )
      .setSize( 150, 20 );
    ui.addSlider( "d" + (idx+1) )
      .setPosition( 10 + 175 * idx, 80 )
      .setRange( 0, 0.1 )
      .setSize( 150, 20 );
  }
}

void draw()
{
  float tp = (frameCount - 1) / 100.0;
  float tc = frameCount / 100.0;

  line( width/2 + evalX( tp ), height/2 + evalY( tp ), 
    width/2 + evalX( tc ), height/2 + evalY( tc ) );
}

void controlEvent( ControlEvent ce )
{
  String name = ce.getName();
  float[] arr = A;
  switch( name.charAt( 0 ) ) {
    case 'A': arr = A; break;
    case 'f': arr = f; break;
    case 'p': arr = p; break;
    case 'd': arr = d; break;
  }
  int idx = int( name.substring( 1 ) ) - 1;
  arr[idx] = ce.getValue();
  background( 50 );
}